<? require(dirname(__FILE__) . "/" . "netpbm.lib.php"); ?>
<?
	function get_image_files($str_folder) {
		global $arr_config_valid_image_types;
		
		$arr_output = NULL;
		
		if(is_dir($str_folder)) {
			$ptr_tmp_folder = opendir($str_folder);
			
			while(FALSE !== ($str_filename = readdir($ptr_tmp_folder))) {
				if($str_filename != "." && $str_filename != "..") {
					$str_file_path = $str_folder . $str_filename;
					
					$arr_pathinfo = pathinfo($str_file_path);
					
					if(isset($arr_pathinfo["extension"]) && in_array(strtolower($arr_pathinfo["extension"]),$arr_config_valid_image_types))
						$arr_output[] = $str_filename;
				}
			}
		}
		
		return $arr_output;
	}

	function make_image_drop_down() {
		$str_output = NULL;
		
		$arr_image_files = get_image_files(dirname(__FILE__));
		
		foreach($arr_image_files as $str_image_file) {
			$str_output .= "<option value=\"" . urlencode($str_image_file) . "\">" . htmlentities($str_image_file) . "</option>" . "\n";
		}
		
		return $str_output;
	}
	
	function make_image_type_drop_down() {
		global $arr_config_valid_image_types;
		
		$str_output = NULL;
		
		foreach($arr_config_valid_image_types as $int_index=>$str_image_ext) {
			$str_output .= "<option value=\"" . intval($int_index) . "\">" . htmlentities($str_image_ext) . "</option>" . "\n";
		}
		
		return $str_output;
	}
	
	function make_action_command_drop_down() {
		global $arr_action_commands;
		
		$str_output = NULL;
		
		foreach($arr_action_commands as $str_index=>$str_value) {
			$str_output .= "<option value=\"" . urlencode($str_index) . "\">" . htmlentities($str_value) . "</option>" . "\n";
		}
	
		return $str_output;
	}
?>
<?
	$arr_action_commands =	Array(
								"scale" => "Skalieren [float]",
								"flip"	=> "Drehen [90,180,270]"
								);
	
	$arr_action_params_limits =	Array(
									"scale" => Array(0,1.5),
									"flip"	=> Array(89,270)
								);
	
	$_ERROR = Array();
	$str_output_images = NULL;
	
	if(isset($_GET["process_form"])) {
		$str_source_image	= dirname(__FILE__) . "/" . $_GET["image_source_path"];
		$str_dest_image		= dirname(__FILE__) . "/" . $_GET["image_dest_name"] . "." . $arr_config_valid_image_types[intval($_GET["image_dest_ext"])];
		
		if(file_exists($str_source_image) && filesize($str_source_image) > 0) {
			$arr_pathinfo = pathinfo($str_dest_image);
			
			if(!file_exists($str_dest_image) && isset($arr_pathinfo["basename"]) && strlen($arr_pathinfo["basename"]) > 0) {
				
				if(isset($_GET["action_command"]) && isset($arr_action_commands[$_GET["action_command"]]) && isset($_GET["action_params"]) && $_GET["action_params"] > 0) {
					$str_action_command	= $_GET["action_command"];
					$str_action_params	= $_GET["action_params"];
					
					$arr_limits = $arr_action_params_limits[$str_action_command];
					
					$bol_proceed = FALSE;
					if($str_action_params > $arr_limits[0] && $str_action_params <= $arr_limits[1])
						$bol_proceed = TRUE;
					
					if($bol_proceed) {
						$str_function = "netpbm__" . $str_action_command;
						
						if(function_exists($str_function)) {
							$str_function($str_source_image,$str_dest_image,$_GET["action_params"]);
							$str_output_images = "<img src=\"" . basename($str_source_image) . "\" border=\"1\"><br><br><img src=\"" . basename($str_dest_image) . "\" border=\"1\">";
							
						}
						else
							$_ERROR[] = "Function " . $str_function . " doesn't exist.";
					}
					else
						$_ERROR[] = "Params out of range (" . $_GET["action_params"] . ").";
				}
				else
					$_ERROR[] = "No or invalid command submitted (" . $_GET["action_command"] . ")";
				
			}
			else
				$_ERROR[] = $str_dest_image . " already exists - not allowed to overwrite.";
		}
		else
			$_ERROR[] = $str_source_image . " doesn't exist.";
	}
	
	if(count($_ERROR) > 0)
		$str_output_images = "<h1>Error</h1>" . implode("<br>",$_ERROR) . "<br><br>" . $str_output_images;
?>
<html>
<body>

<table cellpadding="10" cellspacing="5" border="0">
<form action="<? echo $_SERVER["PHP_SELF"]; ?>" method="GET">
<input type="hidden" name="process_form" value="true">
<tr>
	<td bgcolor="#DDDDDD">
	
	<select name="image_source_path">
	<option value="">bitte whlen ...</option>
	<option value="">&nbsp;</option>
	<? print(make_image_drop_down()); ?>
	</select>
	
	</td>
	<td bgcolor="#DDDDDD">
	
	<table>
	<tr>
		<td><input type="text" name="image_dest_name" size="16" maxlength="32"></td>
		<td>.</td>
		<td>
		
		<select name="image_dest_ext">
		<option value="">bitte whlen ...</option>
		<option value="">&nbsp;</option>
		<? print(make_image_type_drop_down()); ?>
		</select>
		
		</td>
	</tr>
	</table>
	
	</td>
	<td bgcolor="#DDDDDD">
	
	<table>
	<tr>
		<td>
		
		<select name="action_command">
		<option value="">bitte whlen ...</option>
		<option value="">&nbsp;</option>
		<? print(make_action_command_drop_down()); ?>
		</select>
		
		</td>
		<td><input type="text" name="action_params" size="8" maxlength="8"></td>
	</tr>
	</table>
	
	</td>
	<td bgcolor="#DDDDDD"><input type="submit" value="go"></td>
</tr>
</table>
</form>

<? print($str_output_images); ?>

</body>
</html>